#include <stdio.h>
#include "../lclwrld/lclworld.h"
#ifndef GATEWAY
#include "objects.h"
#endif

#define MAXLISTSIZE 500

class listmgr {
  gateway* gmember[MAXLISTSIZE];
  int gtwy_nractive;
  int gtwy_listptr;
  link* lmember[MAXLISTSIZE];
  int link_nractive;
  int link_listptr;
  LAN* Lmember[MAXLISTSIZE];
  int LAN_nractive;
  int LAN_listptr;
  lclworld lclwrld;
  void addneighbors();
 public:
  listmgr();
  ~listmgr();
  int gtwy_add(ipaddr, nametype, commid, int, int, int);
  gateway* gtwy_find(ipaddr);
  int gtwy_remove(ipaddr);
  gateway* gtwy_getfirst();
  gateway* gtwy_getnext();

  int link_add(ipaddr, ipaddr, int,int, int,int, int, unsigned long, int, int,
	       int,int);
  link* link_find(ipaddr, ipaddr);
  int link_remove(ipaddr, ipaddr);
  link* link_getfirst();
  link* link_getnext();

  int LAN_add(ipaddr, int, unsigned long, int, int);
  LAN* LAN_find(ipaddr);
  int LAN_remove(ipaddr);
  LAN* LAN_getfirst();
  LAN* LAN_getnext();

  int readfile(FILE*);
  int savefile(FILE*);
  void printgateways();
  void printlinks();
  void printLANs();
  void removenetwork();
  lclworld* getlclworldptr()            { return &lclwrld; }
  void findcommunity(commid, ipaddr);
  int findNameAddr(ipaddr, ipaddr, nametype, commid, int&, int&);
  int saveNameAddr(ipaddr, ipaddr, nametype, commid, int, int);
  int nrGateways()                      { return gtwy_nractive; }
};
