#define NOPRESS 0
#define PRESS   1
#define LOG     2
#define NOLOG   3

#define GATEWAY 1
#define ROUTER  2
#define HOST    3

#ifndef UNK
#define UNK     0
#define YES     1
#define NO      2
typedef char ipaddr[16];
typedef char nametype[128];
#endif

#define NOCLEAR 0
#define CLEAR   1

#define NRBUFFERS 10

typedef char mstring[80];
typedef char commstr[255];
typedef char msgstr[244];
typedef commstr msgbuf[NRBUFFERS];

class msg {
  int nrBufUsed;
  msgbuf outbuf;
 public:
  msg();
  ~msg();
  void newMsgBuf(int, int, msgstr);
  int addtoMsgBuf(int, int, msgstr);
  int sendOnelineMsg(int, int, msgstr);
  int sendMsgBuf();
  int recvMsgBuf(msgbuf);
  void decipherMsg(commstr, int&, int&, msgstr);
};

class iomgr {
  msg msgMgr;
  msgbuf inbuf;
  int dialogBoxOpen;
  int nrInWaiting;
  int nextToRead;
  int logfileon;
  FILE *logfp;
 public:
  iomgr();
  void logfileOnOff(msgstr);
  int getnextinput(int&, msgstr);
  void printline(int, mstring);
  void openDialog(int);
  void closeDialog();
  void cancelDialogButton();
  int savefilefirst(mstring);
  void drawnode(ipaddr, nametype, int, int, int,int, int);
  void drawLAN(ipaddr, int, int,int);
  void drawlink(ipaddr, ipaddr);
  void undrawnode(ipaddr);
  void undrawLAN(ipaddr);
  void undrawlink(ipaddr, ipaddr);
  void drawNormalBorder(ipaddr, int);
  void drawMonitorBorder(ipaddr, int);
  void newStatus(ipaddr, int, int);
/*  void getresponse(mstring, int, int, mstring);
  void getresponse(int&, int, int, mstring);
  void getresponse(char&, int, int, mstring); */
};
