/*
THIS SOFTWARE IS THE CONFIDENTIAL AND PROPRIETARY PRODUCT OF NYSERNET,
INC.  ANY UNAUTHORIZED USE, REPRODUCTION, OR TRANSFER OF THIS SOFTWARE
IS STRICTLY PROHIBITED.  (C) 1988 NYSERNET, INC.  (SUBJECT TO 
LIMITED DISTRIBUTION AND RESTRICTED DISCLOSURE ONLY.)  ALL RIGHTS RESERVED.
*/
/*****************************************************************************
**
**			varcvt.h
**
** This is the header file for the translator that converts SNMP
** variables from symbolic to numeric form and vice-versa. This converter
** will convert variables of form:
**
**	<symbolic prefix><dot notation IP address> to 
**	<numeric prefix><32 bit IP address>;		(SYMTONUM conversion)
**
** and
**
**	<numeric prefix><32 bit IP address> to
**	<symbolic prefix><dot notation IP address>	(NUMTOSYM conversion)
**
**   Modified by Walt Reissig 2/17/90
************************************************************************/
/* conversion flags */
#define SYMTONUM		1	/* convert symbolic to numeric */
#define NUMTOSYM		2	/* convert numeric to symbolic */

#define VARINITFL		"../etc/snmp.variables"

extern short varcvt();
extern short symtonum();
extern short numtosym();
