#ifndef GATEWAY
#include "../prog/objects.h"
#endif

#define MAXLCLWORLDVARS 100

struct lclworldvar {
  ipaddr addr;
  nametype name;
  commid cid;
  int snmp;
  int ctype;
  addrlist *aliasptr;
};

class lclworld {
  int nrRec;
  lclworldvar* lclworldptr[MAXLCLWORLDVARS];
  int findaddr(ipaddr);
  int findalias(ipaddr);
  int insertrec(ipaddr);
 public:
  lclworld();
  int loadworld();
  int saveworld();
  void printworld();
  int addtoworld(ipaddr);
  int setworldName(nametype, ipaddr);
  int setworldCid(commid, ipaddr);
  int setworldSnmp(int, ipaddr);
  int setworldType(int, ipaddr);
  int setworldAlias(ipaddr, ipaddr);
  inline int addrInworld(ipaddr a)    { return findaddr(a); }
  inline int aliasInworld(ipaddr a)   { return findalias(a); }
  int getworldNamefmAddr(nametype, ipaddr);
  int getworldCidfmAddr(commid, ipaddr);
  int getworldSnmpfmAddr(int&, ipaddr);
  int getworldTypefmAddr(int&, ipaddr);
  int getworldAddrfmAlias(ipaddr, ipaddr);
  int getworldAddrfmName(nametype, ipaddr);
  };
