#include "snmpmsg.h"
#include <stdio.h>
#include <string.h>

main() {
  ipAddr sendaddr;
  commId community;
  responseList response;
  vartable mibVars;
  long timeout;
  int errno;
  int i;
  mibVars.nr = 2;
  strcpy(mibVars.name[0], "_system_sysUpTime");
  strcpy(mibVars.name[1], "_at_atTable_atEntry_atNetAddress");
  strcpy(sendaddr, "192.35.180.3");
  strcpy(community, "public"); 
  timeout = 8;
  errno = snmpmsg(NXT, sendaddr, community, &mibVars, timeout,
		  &response, PRINTEXIT);
  if (errno < 0) 
    printf("message error\n\n");
  else {
    printf("\n%d variables returned\n\n", response.vars.nr);
    for (i = 0; i < response.vars.nr; i++) {
      printf("%s: %s\n", response.vars.name[i], response.asciival[i]);
    }
  }
}
