#include "listmgr.h"
#include "../Xio/Xiomgr.h"

#define PRINTERRORS 0
#define QUIETMODE   1

class actmgr {
  int memNum;
  int notonneighborlist(addrlist*, ipaddr);
  void getsubnet(ipaddr, ipaddr, int);
 public:
  actmgr();
  void opstat(mstring, listmgr&, iomgr&);
  void monitor(mstring, listmgr&, iomgr&);
  void queryone(mstring, listmgr&, iomgr&);
  void querymany(mstring, listmgr&, iomgr&);
  void printdetlist(listmgr&, iomgr&);
  void printcomponent(mstring, listmgr&, iomgr&);
  void printnodes(listmgr&, iomgr&);
  void printlinks(listmgr&, iomgr&);
  void printLANs(listmgr&, iomgr&);
  void drawnetwork(listmgr&, iomgr&);
  void moveNode(msgstr, listmgr&);
  void moveLAN(msgstr, listmgr&);
  int addcomponent(int, mstring, listmgr&, iomgr&);
  void deletecomponent(mstring, listmgr&, iomgr&);
  void map(mstring, listmgr&, iomgr&);
  void trace(mstring, listmgr&, iomgr&);
};
